#include <bits/extc++.h>

#define SET_MAX(a, b) (((b) > (a)) && ((a) = (b), true))

#define int long long

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, T;
    cin >> n >> m >> T;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    auto p = a;
    for (int i = 1; i < n; i++) {
        p[i] += p[i - 1];
    }
    auto get = [&](int i, int j) -> int {
        if (i > j || j < 0 || i < 0) {
            return 0;
        }
        return p[j] - (i == 0 ? 0 : p[i - 1]);
    };
    int ans = 0;
    vector<int> b(m);
    for (int i = 0; i < m; i++) {
        cin >> b[i], b[i]--;
    }
    for (int i = 0; i < n; i++) {
        int cur = 0;
        {
            auto it = lower_bound(b.begin(), b.end(), i);
            if (it != b.end()) {
                int j = *it;
                int s = get(i + 1, j);
                if (s <= T) {
                    SET_MAX(cur, j - i + (T - s) / a[i]);
                }
            }
        }
        {
            auto it = upper_bound(b.begin(), b.end(), i);
            if (it != b.begin()) {
                --it;
                int j = *it;
                int s = get(j, i - 1);
                if (s <= T) {
                    SET_MAX(cur, i - j + (T - s) / a[i]);
                }
            }
        }
        SET_MAX(ans, cur);
    }
    cout << ans << '\n';
    return 0;
}
/*

5 3 10
4 5 2 7 1
1 2 4

4 2 11
4 5 7 10
2 3

 */